<script setup lang="ts">
import { storeToRefs } from 'pinia';
import { computed, ref } from 'vue';
import type { Ref } from 'vue';
import { useTimelineStore } from '@/stores/timeline';
import { handleModeEnum, userType } from '@/enums/enums';
import useTimeline from '@/hooks/useTimeline';
//import Tooltip from '@/components/general/Tooltip.vue';


const props = defineProps<{
    segmentIndex: number
}>();

const store = useTimelineStore();
const { getFullUsable, handleMode, getStyle, postIndex, getLineColor, getLineElementsColor, getLineSize } = storeToRefs(store);
const methods = useTimeline();

const addPostHandler = () => {
    if (getFullUsable.value) {
        postIndex.value = props.segmentIndex;
        handleMode.value = handleModeEnum.ADD;
    }
}
const timelineMargin = computed(() => {
    return -getLineSize.value + 2; //-width + 2px;
});

const addButtonMargin = computed(() => {
    return -60 - timelineMargin.value;// -60px - timelineMargin;
});

const getLineStyle = computed(() => {
    return `solid ${getLineSize.value}px ${getLineColor.value}`;
});

const getAddButtonStyle = computed(() => {
    return {
        fontWeight: getLineSize.value >= 5 ? 800 : getLineSize.value >= 3 ? 600 : undefined,
        marginTop: getLineSize.value === 4 ? "-1px" : getLineSize.value === 5 ? "-2px" : undefined,
        marginLeft: getLineSize.value === 5 ? "-3px" : undefined
    };
})

const computedElementWidth = computed(() => {
    const width = `calc(${getStyle.value.elementWidth}px - 3rem)`;
    return { width: width, minWidth: width, maxWidth: width };
});

</script>
<template>
    <div class="timeline-element flex flex-row gap-2 justify-stretch w-full relative"
        :style="[computedElementWidth, { '--lineWidth': (getStyle.elementWidth - 30) + 'px' }, { '--addColor': getLineElementsColor }, { '--addColorHover': getLineElementsColor + 40 }, { '--timelineMargin': timelineMargin + 'px' }, { '--buttonMargin': addButtonMargin + 'px' }, { '--lineStyle': getLineStyle }]">
        <div class="-top-4 relative inline size-8 z-[11]" v-if="getFullUsable">
            <Tooltip :tooltip="$t('contentPage.post.add')" :style="getAddButtonStyle">
                <button class="timeline-add rounded-md inline w-8" @click="addPostHandler">
                    <strong class="text-center relative block"><i class="ri-add-line text-3xl"></i></strong>
                </button>
            </Tooltip>
        </div>
        <div class="timeline-line grow h-0"></div>
    </div>
</template>
<style scoped>
.timeline-line {
    border: var(--lineStyle);
}

.timeline-add {
    color: var(--addColor);
}

.timeline-add:hover {
    background-color: var(--addColorHover);
}

/*.timeline-element {
    width: var(--elementWidth);
    min-width: var(--elementWidth);
    max-width: var(--elementWidth);
}*/
</style>